;============================================
; Solar OS sample
; to be used with Solar Assembler
;--------------------------------------------

;--------------------------------------------
; This sample shows how print a text
; inside a window
;--------------------------------------------


;----------------------------
; import from this DLL
;----------------------------
import_dll ..\sol_os_kernel.dll

;----------------------------
; the following functions
;----------------------------
	import_func	Window_Create
	import_func	Window_Set_Caption
	import_func	Window_Set_Callback
	import_func	Window_Set_Min_Size

	import_func	Text_Draw
	import_func	Str_Printf CDECL


;----------------------
; define sections
;----------------------
section "code"		class_code
section "data" 		class_data
section	"idata"		class_imports
section "reloc" 	class_relocs


;---------------------
;define entry point
;---------------------
.entry App_Init


;------------------------------
; includes
;------------------------------
include		..\_include\system_32_equ.asm


.data
	main_handle		dd	0
	main_caption		db	"Sol Text Output Sample",0




	text_str		db	"Hello World",0


	tmp_buff1		rb	128
.code


App_Init:

	;----------------------------------
	; create main application window
	;----------------------------------	
	mov	eax,FLAG_WND_ALPHA+FLAG_WND_MINI
	invoke	Window_Create,0,128,128,320,200,eax,WND_TYPE_TOP
	mov	[main_handle],eax

	;-----------------
	; set caption
	;-----------------
	invoke	Window_Set_Caption, eax, main_caption

	;-----------------
	; set callback
	;-----------------
	invoke	Window_Set_Callback,[main_handle],OS_CALL_AFTER,Main_Callback

	;-------------------------------------
	; set minimum resize values
	;-------------------------------------
	invoke	Window_Set_Min_Size,[main_handle],200,108

	mov	eax,[main_handle]
	ret



PROC Main_Callback STDCALL
	USES	ebx,edx,esi,edi
	ARG	wnd_handle,wnd_action,wnd_param1,wnd_param2
	LOCAL	item_ptr	
	;------------------------------------
	; switch on message type
	;------------------------------------
	mov	eax,[wnd_action]

	.IF eax == ACT_PAINT
	
		;-----------------------
		; paint text header
		;-----------------------
		invoke	Text_Draw,[wnd_handle],160,32,text_str,0ff3f1fh

	.ENDIF

	xor	eax,eax
	ret
ENDP




;******************************
;  END OF PROGRAM TEXT
;******************************


