;============================================
; Solar OS sample
; to be used with Solar Assembler
;--------------------------------------------

;--------------------------------------------
; This sample shows how use simple buttons
; inside a window
;--------------------------------------------


;----------------------------
; import from this DLL
;----------------------------
import_dll ..\sol_os_kernel.dll

;----------------------------
; the following functions
;----------------------------
	import_func	Window_Create
	import_func	Window_Create_Ex
	import_func	Window_Set_Caption
	import_func	Window_Set_Callback
	import_func	Window_Set_Min_Size
	import_func	Window_Set_Icon

	import_func	Message_Box

	import_func	Text_Draw
	import_func	Text_Draw_Wrap

	import_func	Str_Printf CDECL


;----------------------
; define sections
;----------------------
section "code"		class_code
section "data" 		class_data
section	"idata"		class_imports
section "reloc" 	class_relocs


;---------------------
;define entry point
;---------------------
.entry App_Init


;------------------------------
; includes
;------------------------------
include		..\_include\system_32_equ.asm


.data
	main_handle		dd	0
	main_caption		db	"Sol 04 Sample",0
	main_text		db	"Some buttons will auto arrange on resize",0


	btn1_caption		db	"Button 1",0
	btn2_caption		db	"Button 2",0
	btn3_caption		db	"Button 3",0
	btn4_caption		db	"Button 4",0

	mbox_caption		db	"Hi!",0
	mbox_msg		db	"Apparently... you have pressed a button",0

	tmp_buff1		rb	128
.code

App_Init:
	;----------------------------------
	; create main application window
	;----------------------------------	
	mov	eax,FLAG_WND_MINI
	invoke	Window_Create_Ex,0,128,128,320,200,eax,WND_TYPE_TOP,main_caption,0,On_Main
	mov	[main_handle],eax

	invoke	Window_Set_Min_Size,[main_handle],250,128

	;---------------------------------------
	; create 4 Buttons
	; - one for each corner
	; - auto-position on resize
	;---------------------------------------
	mov	eax,FLAG_WND_LEFT+FLAG_WND_NO_RESIZE+FLAG_WND_NO_MOVE
	invoke	Window_Create_Ex,[main_handle],	012,032,94,24,		eax,WND_TYPE_BUTTON,btn1_caption,0,On_Btn

	mov	eax,FLAG_WND_LEFT+FLAG_WND_NO_RESIZE+FLAG_WND_NO_MOVE+FLAG_WND_KEEP_BOTTOM	
	invoke	Window_Create_Ex,[main_handle],	012,032,94,24,		eax,WND_TYPE_BUTTON,btn2_caption,0,On_Btn

	mov	eax,FLAG_WND_LEFT+FLAG_WND_NO_RESIZE+FLAG_WND_NO_MOVE+FLAG_WND_KEEP_RIGHT	
	invoke	Window_Create_Ex,[main_handle],	108,032,94,24,		eax,WND_TYPE_BUTTON,btn3_caption,0,On_Btn

	mov	eax,FLAG_WND_LEFT+FLAG_WND_NO_RESIZE+FLAG_WND_NO_MOVE+FLAG_WND_KEEP_BOTTOM+FLAG_WND_KEEP_RIGHT	
	invoke	Window_Create_Ex,[main_handle],	108,032,94,24,		eax,WND_TYPE_BUTTON,btn4_caption,0,On_Btn


	;------------------------
	; return main handle
	;------------------------
	mov	eax,[main_handle]
	ret



PROC On_Btn STDCALL
	USES	ebx,edx,esi,edi
	ARG	wnd_handle,wnd_action,wnd_param1,wnd_param2

	
	;------------------------------------
	; switch on message type
	;------------------------------------
	mov	eax,[wnd_action]

	.IF eax == ACT_LEFT_UP
		;----------------------------------------------
		; BTN :: ON_LEFT_CLICK
		; 
		; Create a message box
		; - OK will not work because of 0 callback 
		;	but you can close it
		;----------------------------------------------
		invoke	Message_Box,mbox_caption,mbox_msg,MSGBOX_BTN_OK,0,0

		; setup MBOX Icon
		invoke	Window_Set_Icon,eax,SIGNS_48,ICON_ATENTION
	.ENDIF

	xor	eax,eax
	ret
ENDP



PROC On_Main STDCALL
	USES	ebx,edx,esi,edi
	ARG	wnd_handle,wnd_action,wnd_param1,wnd_param2

	
	;------------------------------------
	; switch on message type
	;------------------------------------
	mov	eax,[wnd_action]

	.IF eax == ACT_PAINT
		;-----------------------
		; paint main text 
		;-----------------------
		invoke	Text_Draw_Wrap,[wnd_handle],12,64,main_text,07f_ff_1fh

	.ENDIF

	xor	eax,eax
	ret
ENDP




;******************************
;  END OF PROGRAM TEXT
;******************************


