//----------------------------------------------------------
// sol_2.c 
//	 - Sample C application for Solar_OS
//
//----------------------------------------------------------
#include <stdio.h>
#include "sol_os.h"

//-------------------------------------------
// pre define the callback 
//-------------------------------------------
U32 test_wnd_callback (U32 wnd_handle, U32 wnd_action, U32 wnd_param1, U32 wnd_param2);



int main_sol(void)
{
	int	i;
	U32	x_crt;
	U32	y_crt;
	U32 wnd_handle;

	// create a set of cascaded windows
	x_crt = 128;
	y_crt = 64;

	for (i=0; i<7; i++)
	{
		wnd_handle = Window_Create (0, x_crt, y_crt,  256, 128, FLAG_WND_ALPHA, WND_TYPE_TOP);

		Window_Set_Caption (wnd_handle, "Test Window");
		Window_Set_Callback (wnd_handle, OS_CALL_AFTER, (U32)test_wnd_callback);

		x_crt += 8;
		y_crt += 8;
	}

	return 0;
}

//------------------------------------
// the callback for each test window
//------------------------------------
U32 test_wnd_callback (U32 wnd_handle, U32 wnd_action, U32 wnd_param1, U32 wnd_param2)
{

	switch (wnd_action)
	{
		case ACT_PAINT:
			{
				// WND::ON_PAINT --> show a message inside window
				Text_Draw(wnd_handle, 24,32, "Test Message", 0x00FFFF00);
			}
			break;
	}

	return 0;
}

// apparently this function is needed for a DEBUG build ;)
#ifdef _DEBUG
	void __cdecl main()
	{
	}
#endif


