//-------------------------------------------------------
// Solar_OS 
//	minimal header file for "C" programming
//	this should be improved by using the info
//	inside the ASM headers
//
// Author: 
//	Bogdan Valentin Ontanu
//
// Date:
//	2006_11_03	- initial version
//	1009_07_21	- update to new API names
//-------------------------------------------------------


typedef unsigned char  U8; 
typedef signed char    I8; 

typedef unsigned short U16; 
typedef signed short   I16;

typedef unsigned long  U32;
typedef signed long    I32;

#define	API_OK 0

//--------------------------------
// WIndow Types
//--------------------------------
#define	WND_TYPE_TOP			0
#define WND_TYPE_ICON			1

#define WND_TYPE_BUTTON			10
#define WND_TYPE_CHECKBOX		11

#define WND_TYPE_EDIT			20

#define WND_TYPE_SCROLL_VERT	30
#define WND_TYPE_SCROLL_HORIZ	31

#define WND_TYPE_LIST_BOX		40
#define WND_TYPE_TREE			41


//-----------------------------------
// Window Flags
//-----------------------------------
#define FLAG_WND_ALPHA			0x01

#define FLAG_WND_KEEP_RIGHT		0x4000
#define FLAG_WND_KEEP_BOTTOM	0x8000

//----------------------------------
// OS Callback types
//----------------------------------
#define OS_CALL_BEFORE		1
#define OS_CALL_DEFAULT		2
#define OS_CALL_AFTER		3
#define OS_CALL_NOTIFY		4

//-----------------------------------------
// Window Callback Actions
//-----------------------------------------
#define	ACT_PAINT				16
#define ACT_KEY					18
#define	ACT_CLOSE				20

#define	ACT_LEFT_DOWN			2
#define	ACT_LEFT_UP				5

#define	ACT_SCROLL_UP			30
#define	ACT_SCROLL_DOWN			31
#define	ACT_SCROLL_LEFT			32
#define	ACT_SCROLL_RIGHT		33
#define	ACT_SCROLL_TRACK		35

//------------------------------------------
// Sol API
//------------------------------------------
U32 __stdcall	Memory_Allocate (U32 nr_4k_blocks);

void __stdcall	Memory_Release (U32 mem_handle, U32 mem_size );

U32 __stdcall	Window_Create 
				(	
					U32 wnd_parent_hnadle, 
					U32 wnd_x, U32 wnd_y, U32 wnd_dx, U32 wnd_dy,
					U32 wnd_flags, 
					U32 wnd_type
				);

void __stdcall	Window_Set_Callback 
				(	
					U32 wnd_handle, 
					U32 call_type, 
					U32 callback_func_ptr
				);

void __stdcall	Window_Set_Caption (	
					U32 wnd_handle, 
					char *caption_ptr
);

void __stdcall	Text_Draw 
				(	
						U32	wnd_handle,
						U32	wnd_x, U32 wnd_y,
						char *text_string_ptr,
						U32	text_color
				);


